package com.zksy.web.controller.basicData;

import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnvironmentalOtherPenalties;
import com.zksy.system.basicData.service.CrmEnvironmentalOtherPenaltiesService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 环保监管-其他处罚Controller
 *
 * @author sy
 * @date 2024-06-03
 */
@RestController
@RequestMapping("/crmEnvironmentalOtherPenalties")
@Api(tags = "环保监管-其他处罚", description = "环保监管-其他处罚desc")
public class CrmEnvironmentalOtherPenaltiesController extends BaseController{

    @Autowired
    private CrmEnvironmentalOtherPenaltiesService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "环保监管-其他处罚搜索getById")
    public CrmEnvironmentalOtherPenalties getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "环保监管-其他处罚分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "环保监管-其他处罚查询所有")
    public List<CrmEnvironmentalOtherPenalties> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增环保监管-其他处罚
     */
    @PostMapping("/save")
    @ApiOperation(value = "环保监管-其他处罚新增")
    @Log(title = "新增环保监管-其他处罚", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnvironmentalOtherPenalties crmEnvironmentalOtherPenalties) {
        return service.save(crmEnvironmentalOtherPenalties);
    }

    /**
     * 修改环保监管-其他处罚
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "环保监管-其他处罚修改")
    @Log(title = "修改环保监管-其他处罚", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnvironmentalOtherPenalties crmEnvironmentalOtherPenalties) {
        return service.updateById(crmEnvironmentalOtherPenalties);
    }

    /**
     * 导入环保监管-其他处罚
     */
    @ApiOperation("环保监管-其他处罚导入")
    @Log(title = "环保监管-其他处罚", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnvironmentalOtherPenalties> crmEnvironmentalOtherPenaltiesAll = service.list();
            List<CrmEnvironmentalOtherPenalties> list = ExcelUtils.readMultipartFile(file, CrmEnvironmentalOtherPenalties.class,CrmEnvironmentalOtherPenalties.class.getDeclaredFields().length - 2);
            if(crmEnvironmentalOtherPenaltiesAll != null && crmEnvironmentalOtherPenaltiesAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("环保监管-其他处罚导出")
    @Log(title = "环保监管-其他处罚", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnvironmentalOtherPenalties> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"环保监管-其他处罚",wrapperList,CrmEnvironmentalOtherPenalties.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "环保监管-其他处罚", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除环保监管-其他处罚", notes = "删除环保监管-其他处罚")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"环保监管-其他处罚模板");
    }
}

